/** ###################################################################
**     THIS COMPONENT MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename    : LEDGreen.c
**     Project     : ProcessorExpert
**     Processor   : MK10DX128VFM5
**     Component   : LED
**     Version     : Component 01.046, Driver 01.00, CPU db: 3.00.000
**     Compiler    : GNU C Compiler
**     Date/Time   : 2013-01-15, 16:48, # CodeGen: 56
**     Abstract    :
**
**     Settings    :
**
**     Contents    :
**         On     - void LEDGreen_On(void);
**         Off    - void LEDGreen_Off(void);
**         Neg    - void LEDGreen_Neg(void);
**         Get    - byte LEDGreen_Get(void);
**         Put    - void LEDGreen_Put(byte val);
**         Init   - void LEDGreen_Init(void);
**         Deinit - void LEDGreen_Deinit(void);
**
**     License   :  Open Source (LGPL)
**     Copyright : (c) Copyright Erich Styger, 2012, all rights reserved.
**     This an open source software implementing an LED driver using Processor Expert.
**     This is a free software and is opened for education,  research and commercial developments under license policy of following terms:
**     * This is a free software and there is NO WARRANTY.
**     * No restriction on use. You can use, modify and redistribute it for personal, non-profit or commercial product UNDER YOUR RESPONSIBILITY.
**     * Redistributions of source code must retain the above copyright notice.
** ###################################################################*/

/* MODULE LEDGreen. */

#include "LEDGreen.h"

/*
** ===================================================================
**     Method      :  LEDGreen_On (component LED)
**
**     Description :
**         This turns the LED on.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void LEDGreen_On(void)
{
  GPIO2_SetPortBits(NULL, GPIO2_LED_GREEN_MASK);
}

/*
** ===================================================================
**     Method      :  LEDGreen_Off (component LED)
**
**     Description :
**         This turns the LED off.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void LEDGreen_Off(void)
{
  GPIO2_ClearPortBits(NULL, GPIO2_LED_GREEN_MASK);
}

/*
** ===================================================================
**     Method      :  LEDGreen_Neg (component LED)
**
**     Description :
**         This negates/toggles the LED
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void LEDGreen_Neg(void)
{
  GPIO2_TogglePortBits(NULL, GPIO2_LED_GREEN_MASK);
}

/*
** ===================================================================
**     Method      :  LEDGreen_Get (component LED)
**
**     Description :
**         This returns logical 1 in case the LED is on, 0 otherwise.
**     Parameters  : None
**     Returns     :
**         ---             - Status of the LED (on or off)
** ===================================================================
*/
byte LEDGreen_Get(void)
{
  return (byte)((GPIO2_GetPortValue(NULL)&GPIO2_LED_GREEN_MASK)!=0);
}

/*
** ===================================================================
**     Method      :  LEDGreen_Init (component LED)
**
**     Description :
**         Performs the LED driver initialization.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void LEDGreen_Init(void)
{
  LEDGreen_Off();
}

/*
** ===================================================================
**     Method      :  LEDGreen_Put (component LED)
**
**     Description :
**         Turns the LED on or off.
**     Parameters  :
**         NAME            - DESCRIPTION
**         val             - value to define if the LED has to be on or
**                           off.
**     Returns     : Nothing
** ===================================================================
*/
void LEDGreen_Put(byte val)
{
  if(val) {
    LEDGreen_On();
  } else {
    LEDGreen_Off();
  }
}

/*
** ===================================================================
**     Method      :  LEDGreen_Deinit (component LED)
**
**     Description :
**         Deinitializes the driver
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void LEDGreen_Deinit(void)
{
  GPIO2_Deinit(NULL);
}

/* END LEDGreen. */

/*
** ###################################################################
**
**     This file was created by Processor Expert 10.0 [05.03]
**     for the Freescale Kinetis series of microcontrollers.
**
** ###################################################################
*/
