//-----------------------------------------------------------------------------
//  ProcessM.h
/// @file
///
/// @brief Header for the module ProcessM.c
///
/// This is the header for the module ProcessM.c.
///
/// @copyright 2013 TABO - Embedded Systems GmbH & Co. KG - All Rights Reserved
///
/// @status  Draft
/// @date    $Date:$
/// @version $Revision$
/// @author  Eike Mueller(TABO)
///
/// @history
/// Date/Ver   Author/Modification
///
/// 2013-02-12 Eike Mueller(TABO)
///            Draft => V.1.0
/// @endhistory
//-----------------------------------------------------------------------------
#ifndef __PROCESSM_H
 #define __PROCESSM_H

//-----------------------------------------------------------------------------
// Standard-Include-Dateien
//-----------------------------------------------------------------------------
#include "Basetyp.h"

//-----------------------------------------------------------------------------
// Eigene Include-Dateien
//-----------------------------------------------------------------------------
#include "MessageDefs.h"

//-----------------------------------------------------------------------------
// Definitionen, Makros und Konstanten
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Datentypen
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Prototypen der public-Functionen
//-----------------------------------------------------------------------------
// Taskfunction of the task
void ProcessM_TaskFunction( void * pvParameters );
// Gets the measure timeout
UWORD ProcessM_GetMeasureTimeout();
// Gets the config data
void ProcessM_GetConfigData (MSG_DATA_DEVICE_CONFIG * pConfigData);
// Gets the measure mode
MEASURE_MODE ProcessM_GetMeasureMode (void);

#endif //__PROCESSM_H
