//-----------------------------------------------------------------------------
//  Tools.h
/// @file Tools.h
///
/// @brief Header for the mocule Tools.c
///
/// Header for the mocule Tools.c
///
/// @copyright 2012-2013 TABO - Embedded Systems GmbH & Co. KG - All Rights Reserved
///
/// @status  Draft
/// @date    $Date:$
/// @version $Revision$
/// @author  Eike Mueller(TABO)
///
/// @history
/// Date/Ver   Author/Modification
///
/// 2013-02-14 Eike Mueller(TABO)
///            Draft => V.1.0
/// @endhistory
//-----------------------------------------------------------------------------
#ifndef __TOOLS_H
 #define __TOOLS_H

//-----------------------------------------------------------------------------
// Standard-Include-Dateien
//-----------------------------------------------------------------------------
#include "Basetyp.h"

//-----------------------------------------------------------------------------
// Eigene Include-Dateien
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Definitionen, Makros und Konstanten
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Datentypen
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Prototypen der public-Functionen
//-----------------------------------------------------------------------------
// Allocate memory from the head/os
void FreeMemory (void * pMemory);
// Free an allocated memory block
void * AllocateMemory (UWORD MemorySize);
// Calculate a CRC8 checksum on a data stream
UBYTE CalculateCRC8 (PUBYTE pSource, int Offset, int NumOfData, UBYTE CRCValue);

#endif //__TOOLS_H
